% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mcache.R, R/mread.R
\name{mcode_cache}
\alias{mcode_cache}
\alias{mcode}
\title{Write, compile, and load model code.}
\usage{
mcode_cache(model, code, project = tempdir(), ...)

mcode(model, code, project = tempdir(), ...)
}
\arguments{
\item{model}{model name}

\item{code}{character string specifying a \code{mrgsolve} model}

\item{project}{project name}

\item{...}{passed to \code{\link{mread}}}
}
\description{
This is a convenience function that ultimately calls \code{\link{mread}}.
}
\details{
Note that the arguments are in slightly different order than \code{\link{mread}}.  The default \code{project} is \code{tempdir()}.
}
\examples{

code <- '
$CMT DEPOT CENT
$PKMODEL ncmt=1, depot=TRUE
$MAIN
double CL = 1;
double V = 20;
double KA = 1;
'

mod <- mcode("example",code)

}
